#pragma once
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <time.h>
#include <stdio.h>
#include <ctype.h>
#include <utmp.h>
#include <errno.h>
#include <malloc.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <getopt.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <iostream>
#include <set>


#ifndef OLD_UTMP_H
#define OLD_UTMP_H

#define OLD_LINESIZE        12
#define OLD_NAMESIZE        8
#define OLD_HOSTSIZE        16

struct oldutmp {
    short   ut_type;
    int     ut_pid;
    char    ut_line[OLD_LINESIZE];
    char    ut_id[4];
    long    ut_oldtime;
    char    ut_user[OLD_NAMESIZE];
    char    ut_host[OLD_HOSTSIZE];
    long    ut_oldaddr;
};

#endif

#ifndef SHUTDOWN_TIME
#  define SHUTDOWN_TIME 254
#endif

#define UCHUNKSIZE  16384   /* How much we read at once. */

/* Double linked list of struct utmp's */
struct utmplist {
  struct utmp ut;
  struct utmplist *next;
  struct utmplist *prev;
};

struct user_log {
    char user[8];
    char login[7];
    char logout[7];
    struct user_log *next;
};

/* Types of listing */
#define R_CRASH     1 /* No logout record, system boot in between */
#define R_DOWN      2 /* System brought down in decent way */
#define R_NORMAL    3 /* Normal */
#define R_NOW       4 /* Still logged in */
#define R_REBOOT    5 /* Reboot record. */
#define R_PHANTOM   6 /* No logout record but session is stale. */
#define R_TIMECHANGE    7 /* NEW_TIME or OLD_TIME */

using namespace std;
int get_user_count ();
