#include <agent/linux/get_machine_type.h>

std::string get_machine_type () {
    struct addrinfo hints, *info, *p;
    int gai_result;

    char hostname[1024];
    hostname[1023] = '\0';
    gethostname(hostname, 1023);

    memset(&hints, 0, sizeof(hints));
    hints.ai_family = AF_UNSPEC; /*either IPV4 or IPV6*/
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags = AI_CANONNAME;

    gai_result = getaddrinfo(hostname, "http", &hints, &info);

    if (gai_result) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(gai_result));
        return "unknown";
    }

    for(p = info; p; p = p->ai_next) {
		if (!p->ai_canonname) {
			continue;
		}
        if (!strcmp(p->ai_canonname,"server.telecentro.net")) {;
            freeaddrinfo(info);
            return "server";
        }
	}

    freeaddrinfo(info);

    return "client";
}
