#include "agent/post.h"

/*******************************
 *          INVENTORY          *
 *******************************/

int send_inventory(){
	Json::Value inventory = get_inventory();
	Json::FastWriter fastWriter;

#ifdef 	PRINT_JSON
	Json::StyledWriter styledWriter;
	if (!inventory.isNull())
		std::cout << styledWriter.write(inventory);
	else
		std::cout << "Empty inventory object" << std::endl;
#endif

	auto p = cpr::Post(cpr::Url{base_url + "/api/v1/collect"},
                      cpr::Parameters{{"type", "inventory"}},
                      cpr::Body{fastWriter.write(inventory)},
                      cpr::Header{{"content-type", "application/json"}});
	
	if (p.status_code == 200) {
		return 1;
	}

	return 0;
	
}

/***************************************
 *          NETWORK BANDWIDTH          *
 ***************************************/

int send_net_bandwidth(){
	Json::Value net;
	Json::FastWriter fastWriter;

#ifdef 	PRINT_JSON
	Json::StyledWriter styledWriter;
	if (!net.isNull())
		std::cout << styledWriter.write(net);
	else
		std::cout << "Empty network_bandwidth object" << std::endl;
#endif

	auto p = cpr::Post(cpr::Url{base_url + "/api/v1/collect"},
                      cpr::Parameters{{"type", "network_bandwidth"}},
                      cpr::Body{fastWriter.write(net)},
                      cpr::Header{{"content-type", "application/json"}});

	if (p.status_code == 200) {
		return 1;
	}
	
	return 0;

}

/**********************************
 *          USER HISTORY          *
 **********************************/

int send_user_history(){
	Json::Value u_h;
	Json::FastWriter fastWriter;
	
#ifdef 	PRINT_JSON
	Json::StyledWriter styledWriter;
	if (!u_h.isNull())
		std::cout << styledWriter.write(u_h);
	else
		std::cout << "Empty user_history object" << std::endl;
#endif

	auto p = cpr::Post(cpr::Url{base_url + "/api/v1/collect"},
                      cpr::Parameters{{"type", "user_history"}},
                      cpr::Body{fastWriter.write(u_h)},
                      cpr::Header{{"content-type", "application/json"}});
	
	if (p.status_code == 200) {
		return 1;
	}

	return 0;

}
