#ifndef __conf__
#define __conf__
/* Copyright (C) 2004-2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of datasid
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <locale> 
#include <sstream>
#include <map>
#include "datasid-agent.h"
#include "datasid-parse.h"

using namespace std;

class Conf{
    private:
        string dataDir;
        string logDir;
        string proxyConf;
        string webService;

        int delay;
        int daysToExpireLog;
        int updateTries;
        int updateTimeOut;

    public:
        void setDataDir(string);
        void setLogDir(string);
        void setProxyConf(string);
        void setWebService(string);

        void setDelay(int);
        void setDaysToExpireLog(int);
        void setUpdateTries(int);
        void setUpdatTimeOut(int);

        string getDataDir() const;
        string getLogDir() const;
        string getProxyConf() const;
        string getWebService() const;

        int getDelay() const;
        int getDaysToExpireLog() const;
        int getUpdateTries() const;
        int getUpdateTimeOut() const;

        int sizeDataDir();
        int sizeLogDir();
        int sizeProxyConf();
        int sizeWebService();
        int sizeDelay();
        int sizeDaysToExpireLOg();
        int sizeUpdateTries();
        int sizeUpdateTimeOut();

    };

bool checkFileConf(Conf& conf, Agent agent);
Conf datasid_conf(Agent agent);
#endif