/* Copyright (C) 2004-2016 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
 *
 * This file is part of datasid
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 * USA.
 */
#include "../../include/agent/main.h"

using namespace std;

/*
 * set Functions
 */

void Agent::setConfDir(string dir){
    this->confDir = this->prefix + dir;
}

void Agent::setLogFile(string logDir, string file){
    this->logFile = logDir + file;
}

void Agent::setPrefix(string p, int t){
    this->prefix = cutString(p,t);
}

void Agent::setVersion(string v){
    this->version = v;
}

/*
 * get Functions
 */

string Agent::getConfDir() const{
    return this->confDir;
}

string Agent::getLogFile() const{
    return this->logFile;
}

string Agent::getPrefix() const{
    return this->prefix;
}

string Agent::getVersion() const{
    return this->version;
}

/*
 * cutString Function:
 * get the absolute path of the agent
 */

string cutString( string str, int tot){;
    int i=str.size(), count=0;
        while(i-->-1)
        if(str[i] == '/')
            if(++count == tot)
                break;
    return str.substr(0,i);	
}

bool prefixIsSet(string prefix){
    if(prefix.size() == 0)
        throw " ERROR: Prefix not set. ";
    return true;
}

int datasid_agent(){
    Agent agent;
    Conf conf;
    Proxy proxy;
    Common common;

    /* Set agent prefix */
    agent.setPrefix(__FILE__, 3);

    /* Run datasid-common.cpp */
    if(!datasid_common(conf, proxy, agent, common))
        exit(1);

    return 1;
}
